using System;
using System.Text.Json.Serialization;
namespace org.accordproject.finance.loan {
   using org.accordproject.time;
   using org.accordproject.money;
   using concerto;
   enum CurrencyType {
      MONETARY,
      CRYPTOMONETARY,
   }

   class PaymentFrequency : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.finance.loan.PaymentFrequency";
      public int periodMultiplier { get; set; }
      public Duration period { get; set; }
   }
   class Loan : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.finance.loan.Loan";
      public string[] instrumentId { get; set; }
      public string description { get; set; }
      public CurrencyType currencyType { get; set; }
      public CurrencyCode currencyCode { get; set; }
      public CryptoCurrencyCode cryptoCurrencyCode { get; set; }
      public string[] exchangeId { get; set; }
      public string clearanceSystem { get; set; }
      public string definition { get; set; }
      public string lein { get; set; }
      public string facilityType { get; set; }
      public DateTime maturity { get; set; }
      public DateTime creditAgreementDate { get; set; }
      public string tranche { get; set; }
   }
}
